package com.companyname.binaryparam.server.impl;
/**
 * ObjectRiver Inc, http://www.objectriver.net/
 * Copyright (c) 2002-2013, ObjectRiver(tm). All rights reserved.
 */

import com.companyname.binaryparam.common.*;
import com.companyname.binaryparam.server.*;
import com.companyname.binaryparam.common.beans.*;

import javax.websocket.CloseReason;
import javax.websocket.EndpointConfig;
import javax.websocket.Session;
import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.*;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.HashSet;
import java.util.logging.Level;

public class BinaryParamIfaceServerSessionImpl_V1 extends BinaryParamServerRandomImplementation implements BinaryParamIfaceServerInterface_V1, ServerEndPointInterface {
    protected Map<String, Object> userProperties = null;
    protected BinaryParamServerStub_V1 serverStub = null;
    protected Session session__ = null;

    public BinaryParamIfaceServerSessionImpl_V1(BinaryParamServerStub_V1 serverStub) {
        this.serverStub = serverStub;
    }

    /**
     * Implementation WebSocket endpoint routines.
     */
    public void onOpen(Session session, EndpointConfig endpointConfig) {
        this.session__ = session;
        this.userProperties = this.session__.getUserProperties();
    }

    public void onClose(Session session, CloseReason closeReason) {
        this.session__ = null;
    }

    public void onError(Session session, java.lang.Throwable thr) {
        System.out.println(thr.getMessage());
        thr.printStackTrace();
    }

    /**
     * Implement your methods here!
     */
    /**
     * syncwaitmethod void method1( [in] Object input ) throws BinaryException {};
     */
    public void method1(Object input) throws BinaryException {
        System.out.println("Inside method1 method");
        InputStream ins = (InputStream) input;
        DataInputStream dis = new DataInputStream(ins);
        try {
            System.out.println(dis.readInt());
            System.out.println(dis.readInt());
            System.out.println(dis.readInt());
        } catch (IOException ex) {
            System.err.println(ex.getMessage());
        }
    }
    /**
     * syncwaitmethod void method2( [inout] String[1] str, [in] Object input ) {};
     */
    public void method2(String[] str, Object input) {
        System.out.println("Inside method2 method");
        System.out.println("str[0]: " + str[0]);
        str[0] = "Steve";
        InputStream ins = (InputStream) input;
        DataInputStream dis = new DataInputStream(ins);
        try {
            System.out.println(dis.readInt());
            System.out.println(dis.readInt());
            System.out.println(dis.readInt());
        } catch (IOException ex) {
            System.err.println(ex.getMessage());
        }
    }
    /**
     * syncwaitmethod void method3( [in] String str, [in] Object input, [in] Long arg3 ) {};
     */
    public void method3(String str, Object input, Long arg3) {
        System.out.println("Inside method3 method");
        System.out.println("str: " + str);
        System.out.println("arg3: " + arg3);
        InputStream ins = (InputStream) input;
        DataInputStream dis = new DataInputStream(ins);
        try {
            System.out.println(dis.readInt());
            System.out.println(dis.readInt());
            System.out.println(dis.readInt());
        } catch (IOException ex) {
            System.err.println(ex.getMessage());
        }
    }
}
